﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace TestRefresh
{
  [Serializable]
  public class MaClasse : INotifyPropertyChanged, IEditableObject, ICloneable
  {
    #region Variable

    private int m_Id;
    private int m_NbrHour;
    private decimal m_TimeRate;
    private decimal m_TotalPrice;
    private decimal m_Weight;
    private decimal m_TotalPriceByWeight;

    private MaClasse EditableObject;

    #endregion

    #region Property

    public int Id
    {
      get { return m_Id; }
      set
      {
        if (m_Id != value)
        {
          m_Id = value;
          OnPropertyChanged("Id");
        }
      }
    }

    public int NbrHour
    {
      get { return m_NbrHour; }
      set
      {
        if (m_NbrHour != value)
        {
          m_NbrHour = value;
          OnPropertyChanged("NbrHour");
        }
      }
    }

    public decimal TimeRate
    {
      get { return m_TimeRate; }
      set
      {
        if (m_TimeRate != value)
        {
          m_TimeRate = value;
          OnPropertyChanged("TimeRate");
        }
      }
    }

    public decimal TotalPrice
    {
      get { return m_TotalPrice; }
      set
      {
        if (m_TotalPrice != value)
        {
          m_TotalPrice = value;
          OnPropertyChanged("TotalPrice");
        }
      }
    }

    public decimal Weight
    {
      get { return m_Weight; }
      set
      {
        if (m_Weight != value)
        {
          m_Weight = value;
          OnPropertyChanged("Weight");
        }
      }
    }

    public decimal TotalPriceByWeight
    {
      get { return m_TotalPriceByWeight; }
      set
      {
        if (m_TotalPriceByWeight != value)
        {
          m_TotalPriceByWeight = value;
          OnPropertyChanged("TotalPriceByWeight");
        }
      }
    }

    #endregion

    #region Function

    private void Update(MaClasse a)
    {
      Id = a.Id;
      NbrHour = a.NbrHour;
      TimeRate = a.TimeRate;
      TotalPrice = a.TotalPrice;
      Weight = a.Weight;
      TotalPriceByWeight = a.TotalPriceByWeight;
    }

    #endregion

    #region INotifyPropertyChanged Members

    public event PropertyChangedEventHandler PropertyChanged;

    public void OnPropertyChanged(string PropertyName)
    {
      if (PropertyChanged != null)
        PropertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(PropertyName));
    }

    #endregion

    #region IEditableObject Members

    public void BeginEdit()
    {
      if (EditableObject == null)
        EditableObject = (MaClasse)this.Clone();
    }

    public void CancelEdit()
    {
      if (EditableObject != null)
        Update(EditableObject);
    }

    public void EndEdit()
    {
      EditableObject = null;
    }

    #endregion

    #region ICloneable Members

    public object Clone()
    {
      MaClasse a = new MaClasse();
      a.Id = Id;
      a.NbrHour = NbrHour;
      a.TimeRate = TimeRate;
      a.TotalPrice = TotalPrice;
      a.Weight = Weight;
      a.TotalPriceByWeight = TotalPriceByWeight;

      return a;
    }

    #endregion
  }


}
