﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TestRefresh
{
  public partial class frmMain : Form
  {
    public frmMain()
    {
      InitializeComponent();
      dg.AutoGenerateColumns = true;
      IsBinding = false;
    }

    #region Variable

    private MaClasseCollection MCC;
    private bool IsBinding;

    #endregion

    #region Function

    private void CreateData()
    {
      // Creation de données pour Test
      MCC = new MaClasseCollection();
      MaClasse mc = null;

      mc = new MaClasse();
      mc.Id = 1;
      mc.NbrHour = 1;
      mc.TimeRate = 10;
      mc.TotalPrice = mc.NbrHour * mc.TimeRate;
      mc.Weight = 5;
      mc.TotalPriceByWeight = mc.TotalPrice / mc.Weight;
      MCC.Add(mc);

      mc = new MaClasse();
      mc.Id = 2;
      mc.NbrHour = 2;
      mc.TimeRate = 20;
      mc.TotalPrice = mc.NbrHour * mc.TimeRate;
      mc.Weight = 10;
      mc.TotalPriceByWeight = mc.TotalPrice / mc.Weight;
      MCC.Add(mc);

      mc = new MaClasse();
      mc.Id = 3;
      mc.NbrHour = 3;
      mc.TimeRate = 30;
      mc.TotalPrice = mc.NbrHour * mc.TimeRate;
      mc.Weight = 15;
      mc.TotalPriceByWeight = mc.TotalPrice / mc.Weight;
      MCC.Add(mc);
    }

    private void SetBindingSource()
    {
      txtId.DataBindings.Add(new Binding("Text", this.bs, "Id", true, DataSourceUpdateMode.OnPropertyChanged));
      txtNbrHour.DataBindings.Add(new Binding("Text", this.bs, "NbrHour", true, DataSourceUpdateMode.OnPropertyChanged));
      txtTimeRate.DataBindings.Add(new Binding("Text", this.bs, "TimeRate", true, DataSourceUpdateMode.OnPropertyChanged));
      txtTotalPrice.DataBindings.Add(new Binding("Text", this.bs, "TotalPrice", true, DataSourceUpdateMode.OnPropertyChanged));
      txtWeight.DataBindings.Add(new Binding("Text", this.bs, "Weight", true, DataSourceUpdateMode.OnPropertyChanged));
      txtTotalPriceByWeight.DataBindings.Add(new Binding("Text", this.bs, "TotalPriceByWeight", true, DataSourceUpdateMode.OnPropertyChanged));
    }

    private void OnItemChanged(object Row, string ColumnName, object Value, PropertyDescriptor e)
    {
      switch (ColumnName)
      {
        case "NBRHOUR":
          // Si Nbr heure change --> Calcul du Prix total et du Prix au Kg
          CalCulTotalPrice(Row as MaClasse);
          CalCulTotalPriceByWeight(Row as MaClasse);
          break;

        case "TIMERATE":
          // Si taux horaire change --> Calcul du Prix total et du Prix au Kg
          CalCulTotalPrice(Row as MaClasse);
          CalCulTotalPriceByWeight(Row as MaClasse);
          break;

        case "WEIGHT":
          // Si Poids change --> Calcul du Prix au Kg
          CalCulTotalPrice(Row as MaClasse);
          break;

        default:
          break;
      }
    }

    private void CalCulTotalPrice(MaClasse mc)
    {
      mc.TotalPrice = mc.NbrHour * mc.TimeRate;
    }

    private void CalCulTotalPriceByWeight(MaClasse mc)
    {
      if(mc.Weight == 0)
        mc.TotalPriceByWeight = 0;
      else
        mc.TotalPriceByWeight = mc.TotalPrice / mc.Weight;
    }

    #endregion

    #region Event Control

    private void bs_ListChanged(object sender, ListChangedEventArgs e)
    {
      if (e.ListChangedType == ListChangedType.ItemChanged)
        OnItemChanged(bs.Current, e.PropertyDescriptor.DisplayName.ToUpper(), e.PropertyDescriptor.GetValue(bs.Current), e.PropertyDescriptor);
    }

    private void btnRefresh_Click(object sender, EventArgs e)
    {
      CreateData();
      bs.DataSource = MCC;
      if (!IsBinding)
      {
        SetBindingSource();
        IsBinding = true;
      }
    }

    #endregion

  }
}
